package exercice2_repertoire;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;


public class Contact implements Comparable<Contact> {
	private final String nom;
	private final String prenom;
	private Set<NumTel> numeros;
	public Contact(String nom, String prenom) {
		this.nom = nom;
		this.prenom = prenom;
		this.numeros = new HashSet<NumTel>();
	}
	public String getNom() {
		return nom;
	}
	public String getPrenom() {
		return prenom;
	}
	public boolean addNumero(NumTel n) {
		return numeros.add(n);
	}
	public boolean containsNumTel(NumTel n) {
		return numeros.contains(n);
	}
	/**
	 * Cherche un numéro de téléphone contenant le numéro n.
	 * Cette méthode a le comportement attendu car haschode et equals ne prennent en compte que l'attribut numero.
	 * @param n
	 * @return
	 */
	public boolean containsNumTel(int n) {
		return numeros.contains(new NumTel(n));
	}
	@Override
	public String toString() {
		return "Contact [nom=" + nom + ", prenom=" + prenom + ", numeros=" + numeros.toString() + "]";
	}
	public boolean removeNumTelDenum(int num) {
		Iterator<NumTel> iter = numeros.iterator();
		while (iter.hasNext()) {
			NumTel n = iter.next();
			if (n.getNumero()==num){
				iter.remove();
				return true;		
			}
		}
		return false;
	}
	// La comparaison se fait uniquement sur les noms puis les prénoms
	public int compareTo(Contact o) {
		String nt = this.getNom().toUpperCase();
		String no = o.getNom().toUpperCase();
		if (nt.equals(no)) {
			return this.getPrenom().toUpperCase().compareTo(o.getPrenom().toUpperCase());
		} else
			return nt.compareTo(no);
	}

}
