package exercice2_repertoire;

import java.util.Map;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeMap;
import java.util.TreeSet;

public class Repertoire {
	private TreeMap<String,Contact> rep = new TreeMap<String,Contact> ();
	
	public void add(Contact c) {
		String key = c.getNom().toUpperCase()+" "+c.getPrenom().toUpperCase();
		rep.put(key, c);
	}
	public boolean containsDeNom(String nom, String prenom) {
		String key=nom.toUpperCase()+" "+prenom.toUpperCase();
		return rep.containsKey(key);
	}
	public void affiche(String nom, String prenom) {
		if (this.containsDeNom(nom, prenom)) {
			String key=nom.toUpperCase()+" "+prenom.toUpperCase();
			System.out.println(rep.get(key).toString());
		}
		
	}
	public void affiche() {
		Set<String> s = rep.keySet();
		SortedSet<String> se = new TreeSet<String>(s);
		for (String k : se) {
			System.out.println(rep.get(k));
		}
	}
	public TreeSet<Contact> contactsDeNom(String n){
		TreeSet<Contact> res = new TreeSet<Contact>();
		Set<Map.Entry<String, Contact>> s = rep.entrySet();
		for (Map.Entry<String, Contact> e : s) {
			Contact c = e.getValue();
			if(c.getNom().toUpperCase().equals(n.toUpperCase())) {
				res.add(c);
			}
		}
		return res;
	}
	public TreeSet<Contact> contactsDeNum(int n){
		TreeSet<Contact> res = new TreeSet<Contact>();
		Set<Map.Entry<String, Contact>> s = rep.entrySet();
		for (Map.Entry<String, Contact> e : s) {
			Contact c = e.getValue();
			if(c.containsNumTel(n)) {
				res.add(c);
			}
		}
		return res;
	}

}
